//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "UtAvion.h"

//---------------------------------------------------------------------------

#pragma package(smart_init)

tAvion::tAvion(int nC, int nF)
{
        distribucion = new matrizBool(nC, nF, false);
        capacidad = nC * nF;
        numAsientosOcupados = numAsientosFacturados = 0;
}
tAvion::~tAvion()
{
        delete distribucion;
};

bool tAvion::reservaAsiento()
{
        if(numAsientosOcupados < capacidad)
        {
                ++numAsientosOcupados;
                return true;
        }
        else return false;
}

bool tAvion::eliminaAsiento()
{
        if(numAsientosOcupados > 0)
        {
                --numAsientosOcupados;
                return true;
        }
        else return false;
}

bool tAvion::salvar(ofstream& sal) const
{
        sal.write((char*)& capacidad, sizeof(int));
        sal.write((char*)& numAsientosOcupados, sizeof(int));
        sal.write((char*)& numAsientosFacturados, sizeof(int));
        distribucion->salvar(sal);
        return sal;
}

bool tAvion::cargar(ifstream& ent)
{
        ent.read((char*)& capacidad, sizeof(int));
        ent.read((char*)& numAsientosOcupados, sizeof(int));
        ent.read((char*)& numAsientosFacturados, sizeof(int));
        distribucion->cargar(ent);
        return ent;
}


bool tAvion::facturAsiento(unsigned int col, unsigned int fil)
{
        bool aux;
        if (distribucion->getElem(col, fil, aux))
        {
                if(!aux)
                {
                        if(distribucion->setElem(col, fil, true))
                        {
                                ++numAsientosFacturados;
                                return true;
                        }
                        else return false;
                }
                else return false;
        }
        else return false;
}
