//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "UtVuelo.h"

//---------------------------------------------------------------------------

#pragma package(smart_init)

tVuelo::tVuelo(const string& or, const string& des, const tHora& hs, const tHora& dur, const string& com, int idV, int pre)
{
        randomize();
        origen = or;
        destino = des;
        horaSalida = hs;
        duracion = dur;
        company = com;
        IdVuelo = idV;
        precioBillete = pre;
        avion = new tAvion(random(5) + 1, random(10) + 1);
        //avion = new tAvion(1, 1);
}

tVuelo::~tVuelo()
{
        delete avion;
}

bool tVuelo::setAvion(tAvion* av)
{
        if(av == NULL)
        {
                return false;
        }
        else
        {
                delete avion;
                localizadores.clear();
                avion = av;
                return true;
        }
}

bool tVuelo::salvar(ofstream& sal) const
{
        int i;
        horaSalida.salvar(sal);
        duracion.salvar(sal);
        sal.write((char*)& IdVuelo, sizeof(int));
        sal.write((char*)& precioBillete, sizeof(int));
        i = origen.size();
        sal.write((char*)& i, sizeof(int));
        sal.write(origen.data(), sizeof(char) * origen.size());
        i = destino.size();
        sal.write((char*)& i, sizeof(int));
        sal.write(destino.data(), sizeof(char) * destino.size());
        i = company.size();
        sal.write((char*)& i, sizeof(int));
        sal.write(company.data(), sizeof(char) * company.size());
        avion->salvar(sal);

        unsigned int aux = localizadores.size();
        sal.write((char*)& aux , sizeof(unsigned int));
        if(localizadores.size() > 0)
        {
                for(unsigned int i = 0; i < localizadores.size(); i++)
                {
                        localizadores.at(i).salvar(sal);
                }
        }

        return sal;
}

bool tVuelo::cargar(ifstream& ent)
{
        char aux;
        int tam;
        tLocalizador au;
        origen = "";
        destino = "";
        company = "";
        horaSalida.cargar(ent);
        duracion.cargar(ent);
        ent.read((char*)& IdVuelo, sizeof(int));
        ent.read((char*)& precioBillete, sizeof(int));
        ent.read((char*)& tam, sizeof(int));
        for(int i = 0; i < tam; i++)
        {
                ent.read((char*)& aux, sizeof(char));
                origen += aux;
        }
        ent.read((char*)& tam, sizeof(int));
        for(int i = 0; i < tam; i++)
        {
                ent.read((char*)& aux, sizeof(char));
                destino += aux;
        }
        ent.read((char*)& tam, sizeof(int));
        for(int i = 0; i < tam; i++)
        {
                ent.read((char*)& aux, sizeof(char));
                company += aux;
        }
        delete avion;
        avion = new tAvion(1);
        avion->cargar(ent);

        localizadores.clear();
        unsigned int listcont;
        ent.read((char*)& listcont, sizeof(unsigned int));
        if(listcont > 0)
        {
                tLocalizador aux;
                while(listcont != localizadores.size())
                {
                        aux.cargar(ent);
                        localizadores.push_back(aux);
                }
        }

        return ent;
}

bool tVuelo::cerrado() const
{
        return (avion->dameAsientosFacturados() >= avion->dameCapacidad());
}

bool tVuelo::buscaReserva(int idLoc, tLocalizador& l) const
{
        int pos;
        if(buscaLoc(idLoc, pos, 0, avion->dameCapacidad()))
        {
                l = localizadores.at(pos);
                return true;
        }
        else return false;
}

bool tVuelo::facturar(tLocalizador& loc, tSize col, tSize fil)
{
        bool aux;
        if(avion->facturAsiento(col, fil))
        {
                localizadores.at(loc.dameIdLocalizador()).facturar();
                loc = localizadores.at(loc.dameIdLocalizador());
                return true;
        }
        else return false;
}

bool tVuelo::buscaLoc(int idLoc, int & pos, int ini, int fin) const
{
        try
        {       unsigned int i = 0;
                while(i < localizadores.size() && localizadores.at(i).dameIdLocalizador() != idLoc)
                {
                        i++;
                }
                pos = i;
                return (i < localizadores.size());
        } catch(Error &e) { return false; }
}
